version: "3.5"

services:
  traefik:
    image: "traefik:v2.8"
    container_name: "traefik"
    command:
      #- "--log.level=DEBUG"
      - "--api.insecure=true"
      - "--providers.docker=true"
      - "--providers.docker.exposedbydefault=false"
      - "--entrypoints.web.address=:80"
    ports:
      - "80:80"
      - "8080:8080"
    volumes:
      - "/var/run/docker.sock:/var/run/docker.sock:ro"

  web:

    image: ${IMAGE_NAME:-registry.gitlab.com/kontinu/sre-bootcamp/new-app-model/app}
    build:
      context: app/
    environment:
      - REDIS_HOST=redis
      - FOO=${FOO:-BAR}
      - MICRO_URL=http://${SUBDOMAIN:-app}.traefik.me/micro
      - OTEL_SERVICE_NAME=web
    # env_file:
    #   - otel.env
    # adds self-healing availability
    healthcheck:
      test: wget -O- http://localhost:5000/health
      interval: 15s
      timeout: 3s
      retries: 3
      start_period: 2s
    labels:
      - "traefik.enable=true"
      - "traefik.http.services.app.loadbalancer.server.port=5000"
      - "traefik.http.routers.app.rule=Host(`${SUBDOMAIN:-app}.traefik.me`)"
      - "traefik.http.routers.app.entrypoints=web"

  micro:
    image: ${IMAGE_NAME:-registry.gitlab.com/kontinu/sre-bootcamp/new-app-model/micro}
    build:
      context: micro
    environment:
      - REDIS_HOST=redis
      - OTEL_SERVICE_NAME=micro
    # env_file:
    #   - otel.env
    healthcheck:
      test: wget -O- http://localhost:5000/health
      interval: 15s
      timeout: 3s
      retries: 3
      start_period: 2s
    labels:
      - "traefik.enable=true"
      - "traefik.http.services.micro.loadbalancer.server.port=5000"
      - "traefik.http.routers.micro.rule=Host(`${SUBDOMAIN:-app}.traefik.me`) && PathPrefix(`/micro`)"

      - "traefik.http.routers.micro.middlewares=micro-stripprefix"
      - "traefik.http.middlewares.micro-stripprefix.stripprefix.prefixes=/micro"
      - "traefik.http.routers.micro.entrypoints=web"


  redis:
    image: "redis:alpine"
    deploy:
      replicas: 1
    ports:
      - "6379:6379"
